--VERSION DATE 03-03-2008
--Run this procedure against all company databases
--EXEC spSmartFill '1','sa', -1, 'AB'
--SELECT * FROM DYNAMICS.DBO.SF001
--DELETE DYNAMICS.DBO.SF001
IF EXISTS(SELECT * FROM sysobjects WHERE name = 'spSmartFill') DROP PROC spSmartFill
GO

CREATE PROC spSmartFill 
	@SmartFillObjectID INT,
	@UserID CHAR(15),
	@CompanyID INT,
	@SearchValue CHAR(50),
	@SearchValue2 CHAR(50),
	@SearchValue3 CHAR(50),
	@SearchValue4 CHAR(50),
	@SearchValue5 CHAR(50),
	@SearchValue6 CHAR(50),
	@SearchValue7 CHAR(50),
	@SearchValue8 CHAR(50),
	@SearchValue9 CHAR(50)
AS 
DECLARE @SmartFillObjectName CHAR(50)
SET @SmartFillObjectName = (SELECT SF_Object_Name FROM DYNAMICS.dbo.SF002 WHERE SF_Object_ID = @SmartFillObjectID)

IF @SmartFillObjectName = 'Customers' BEGIN
	INSERT INTO DYNAMICS.dbo.SF001 
		(USERID,
		CMPANYID,
		SF_Return_Field_String,
		SF_Return_Field_Account_1,
		SF_Return_Field_Account_2,
		SF_Return_Field_Account_3,
		SF_Return_Field_Account_4,
		SF_Return_Field_Account_5,
		SF_Return_Field_Account_6,
		SF_Return_Field_Account_7,
		SF_Return_Field_Account_8,
		SF_Return_Field_Account_9,
		SF_Return_Field_Account_10,
		SF_Return_Field_Integer,
		SF_Return_Field_Currency,
		SF_Field_Value_1,
		SF_Field_Value_2,
		SF_Field_Value_3,
		SF_Field_Value_4,
		SF_Field_Value_5,
		SF_Field_Value_6,
		SF_Field_Value_7,
		SF_Field_Value_8,
		SF_Field_Value_9,
		SF_Field_Value_10)
	SELECT 
		@UserID,
		@CompanyID,
		'',
		'', --Account Segment 1
		'', --Account Segment 2
		'', --Account Segment 3
		'', --Account Segment 4
		'', --Account Segment 5
		'', --Account Segment 6
		'', --Account Segment 7
		'', --Account Segment 8
		'', --Account Segment 9
		'', --Account Segment 10
		0,  --Integer Placeholder
		0,  --Currency Placeholder
		CUSTNMBR,  --Display Field 1
		CUSTNAME,  --Display Field 2
		CUSTCLAS,  --Display Field 3
		'', --Display Field 4
		'', --Display Field 5
		'', --Display Field 6
		'', --Display Field 7
		'', --Display Field 8
		'', --Display Field 9
		''  --Display Field 10
	FROM RM00101
		WHERE CUSTNAME LIKE '%' + LTRIM(RTRIM(@SearchValue)) + '%'	-- Contains search
		--WHERE CUSTNAME LIKE LTRIM(RTRIM(@SearchValue)) + '%'		-- Begins With search
	RETURN @@ROWCOUNT
END
GO	

GRANT EXECUTE ON spSmartFill TO DYNGRP
GO
